# This is a copy of the upstream conda recipe for this package
# hosted at github.com/conda-forge/lal-feedstock and licensed
# under the terms of the BSD 3-Clause license.
# This is only for CI purposes, and should not be considered
# production-ready at any time.

{% set name = "lalsimulation" %}

# set version based on nightly
# (we rebuild the nightly version ourselves because the tarball might have
#  been generate on a different day)
{% set base_version = "3.0.0.1" %}
{% set nightly_version = "" %}
{% if nightly_version %}
{% set version = base_version + "-dev" + datetime.datetime.utcnow().strftime("%Y%m%d") %}
{% else %}
{% set version = base_version %}
{% endif %}

# dependencies
{% set lal_version = "7.1.0a0" %}
{% set swig_version = "3.0.10" %}

package:
  name: {{ name }}-split
  version: {{ version|replace('-', '.') }}

source:
  url: file://@TARBALL@
  sha256: @SHA256@

build:
  error_overdepening: true
  error_overlinking: true
  number: 9999
  script_env:
    - CI_COMMIT_TAG
    - CI_PIPELINE_SOURCE
    - GITLAB_CI
  skip: true  # [win]

requirements:
  build:
    - {{ compiler('c') }}
    - llvm-openmp  # [osx]
    - make
    - pkg-config >=0.18.0
    - swig >={{ swig_version }}
  host:
    - gsl
    - liblal >={{ lal_version }}
    - libgomp  # [linux]
    - llvm-openmp  # [osx]

outputs:
  - name: liblalsimulation
    script: install-lib.sh
    build:
      error_overdepending: true
      error_overlinking: true
      run_exports:
        - {{ pin_subpackage("liblalsimulation", max_pin="x") }}
    requirements:
      build:
        - {{ compiler('c') }}
        - llvm-openmp  # [osx]
        - make
        - swig >={{ swig_version }}
      host:
        - gsl
        - liblal >={{ lal_version }}
        - libgomp  # [linux]
        - llvm-openmp  # [osx]
      run:
        - gsl
        - liblal >={{ lal_version }}
        - llvm-openmp  # [osx]
      run_constrained:
        - lalsimulation >=2.5.0
        - python-lalsimulation >=2.5.0
    test:
      requires:
        - pkg-config
      commands:
        # check library
        - test -f ${PREFIX}/lib/liblalsimulation${SHLIB_EXT}  # [unix]
        # check activate variables
        - test "${LALSIMULATION_DATADIR}" = "${PREFIX}/share/lalsimulation"  # [unix]
        # check pkg-config
        - pkg-config --print-errors --exact-version "${PKG_VERSION}" lalsimulation
    about:
      home: https://wiki.ligo.org/Computing/LALSuite
      doc_url: https://lscsoft.docs.ligo.org/lalsuite/lalsimulation/
      dev_url: https://git.ligo.org/lscsoft/lalsuite/
      license: GPL-2.0-or-later
      license_family: GPL
      license_file: COPYING
      summary: LSC Algorithm Simulation Library
      description: |
        The LSC Algorithm Simulation Library for gravitational wave data
        analysis.
        This package contains the shared-object libraries needed to run
        applications that use the LAL Simulation library.

  - name: python-lalsimulation
    script: install-python.sh
    build:
      error_overdepending: true
      error_overlinking: true
      ignore_run_exports:
        - openssl
        # ignore run_exports from python's recipe
        - python
    requirements:
      build:
        - {{ compiler('c') }}
        - help2man >=1.37  # [build_platform == target_platform]
        - make
        - pkg-config >=0.18.0
        - swig >={{ swig_version }}
        # extras for cross-compilation:
        - cross-python_{{ target_platform }}  # [build_platform != target_platform]
        - numpy                               # [build_platform != target_platform]
        - python                              # [build_platform != target_platform]
      host:
        - {{ pin_subpackage('liblalsimulation', exact=True) }}
        - numpy
        - python
        # extras to assist the solver, but not actually used
        - openssl
      run:
        - {{ pin_subpackage('liblalsimulation', exact=True) }}
        - mpmath >=1.0.0
        - {{ pin_compatible('numpy') }}
        - python
        - python-lal >={{ lal_version }}
    test:
      requires:
        - pytest >=4.0.0a0
      source_files:
        - test/python
      commands:
        - python -m pytest -ra -v --junit-xml=${CI_PROJECT_DIR:-.}/junit-python${PY_VER}.xml test/python
      imports:
        - lalsimulation
        - lalsimulation.nrfits
        - lalsimulation.tilts_at_infinity
    about:
      home: https://wiki.ligo.org/Computing/LALSuite
      doc_url: https://lscsoft.docs.ligo.org/lalsuite/lalsimulation/
      dev_url: https://git.ligo.org/lscsoft/lalsuite/
      license: GPL-2.0-or-later
      license_family: GPL
      license_file: COPYING
      summary: LSC Algorithm Simulation Library
      description: |
        The LSC Algorithm Simulation Library for gravitational wave data
        analysis.
        This package contains the python bindings.

  - name: lalsimulation
    script: install-bin.sh
    build:
      error_overdepending: true
      error_overlinking: true
      ignore_run_exports:
        - openssl
        - python
    requirements:
      build:
        - {{ compiler('c') }}
        - help2man >=1.37  # [build_platform == target_platform]
        - make
      host:
        - gsl
        - liblal >={{ lal_version }}
        - {{ pin_subpackage('liblalsimulation', exact=True) }}
        - python
        # extras to assist the solver, but not actually used
        - openssl
      run:
        - gsl
        - liblal >={{ lal_version }}
        - {{ pin_subpackage('liblalsimulation', exact=True) }}
        - mpmath >=1.0.0
        - python
        - {{ pin_subpackage('python-lalsimulation', exact=True) }}
    test:
      commands:
        - lalsimulation_version --verbose
        - lalsim-bh-qnmode -l 0 -m 0 -s 0
        - lalsim-bh-ringdown -M 10 -a 0 -r 100 -e 0.001 -i 0 -l 2 -m 2
        - lalsim-bh-sphwf -a 0 -l 2 -m 2 -s 0
        - lalsim-burst -w SineGaussian -q 10 -f 100 -H 1e-21 1> /dev/null
        - lalsim-detector-noise -C -t 1 -r 10
        - lalsim-detector-strain --help
        - lalsim-inject --help
        - lalsim-inspiral > /dev/null
        - lalsim-ns-eos-table -n ALF1 1> /dev/null
        - lalsim-ns-mass-radius -n ALF1 1> /dev/null
        - lalsim-ns-params -n ALF1
        - lalsim-sgwb --geo -t 1 -r 100 -W 1 1> /dev/null
        - lalsim-unicorn --help

about:
  home: https://wiki.ligo.org/Computing/LALSuite
  doc_url: https://docs.ligo.org/lscsoft/lalsuite/lalsimulation/
  dev_url: https://git.ligo.org/lscsoft/lalsuite/
  license: GPL-2.0-or-later
  license_family: GPL
  license_file: COPYING
  summary: LSC Algorithm Simulation Library
  description: |
    The LSC Algorithm Simulation Library for gravitational wave data
    analysis.

extra:
  feedstock-name: lalsimulation
  recipe-maintainers:
    - duncanmmacleod
    - skymoo
